from picamera.array import PiRGBArray
from picamera import PiCamera
import time
import cv2

camera = PiCamera()
camera.resolution = (640, 480)
camera.framerate = 24
raw = PiRGBArray(camera, size=(640, 480))
time.sleep(0.1) # allow the camera to warmup

fourcc = cv2.VideoWriter_fourcc(*'XVID')
out = cv2.VideoWriter('captured.avi',fourcc, 20.0, (640,480))

for frame in camera.capture_continuous(raw, format="bgr", use_video_port=True):
    image = frame.array
    cv2.imshow("Frame", image)
    out.write(image)
    raw.truncate(0) # clear the stream
    if cv2.waitKey(1) & 0xFF == ord("q"):
        break

camera.close()
out.release()
cv2.destroyAllWindows()